<modal-category-index>

	<div class="popup-ovelray" id="modal-category-index" style="display:none">
		<div class="popup-window popup-md">
            <div class="popup-heading">
                <div class="title" show="{ state.category.id }">
                	<a href="/category/{ state.category.slug }"><strong>{ state.category.title }</strong></a>
                </div>
                <a href="#" class="close" onclick="{ close_popup }">&times;</a>
            </div>
            <div class="popup-body">
            	<div class="categories-index clearfix">
            		<a href="/category/{ category.slug }" each="{ category in state.categories }">{ category.title }</a>
            	</div>
            </div>

            <loader-icon class="control-loader" if="{ state.loading }"></loader-icon>
        </div>
	</div>


	<script>
		this.state = {
			category: {},
			categories: [],

			loading: false,
		}


		this.toggle_loader = value => {
			this.state.loading = value;
			this.update();
		}


		this.initialize = category_id => {
			console.log("modal-category-index initialize:" + category_id);
			this.state.category_id = category_id;
			this.show_popup();
			if (category_id != this.state.category.id) {
				this.state.categories = [];
				this.load(category_id);
			}
		}


		this.show_popup = () => {
			var tag = this;
			$('#modal-category-index').fadeIn('fast', function() {
                tag.update();
            });
		}


		this.close_popup = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			$('#modal-category-index').fadeOut('fast');
		}


		this.load = category_id => {
			var tag = this;
			// load professionals
			request('category_index',
				{
					'id': category_id
				},
				function(result) {
					console.log("category_index");
					console.log(result);

					tag.state.category = result.category;
					tag.state.categories = result.categories;
					
					tag.update();

				}, null, this.toggle_loader
			);
		}


		this.on("mount", function() {
			var tag = this;
            // close popup if click is on popup overlay
            $('#modal-category-index').on("click", function(event) {
                if (!$(event.target).attr("href")) {
                    tag.close_popup(event);
                }
            });
		});

	</script>
</modal-category-index>